//------------------------------------------------------------------------------
// <autogenerated>
//     This code was generated by Measurement Studio.
//     Runtime Version: 1.1.4322.573
//
//     Changes to this file may cause incorrect behavior and will be lost if 
//     the code is regenerated.
// </autogenerated>
//------------------------------------------------------------------------------

namespace InstrumentDriverInterop.Ivi
{
    using System;
    using System.Runtime.InteropServices;
    
    
    public class niDMM : object, System.IDisposable
    {
        
        private System.IntPtr _handle;
        
        private bool _disposed = true;
        
        ~niDMM(){Dispose(false);}

        /// <summary>
        /// 
        /// Creates a new IVI instrument driver session. 
        /// Opens a session to the device you specify for the Resource_Name parameter. 
        /// If the ID Query parameter is set to TRUE, this function queries the instrument ID and checks that it is valid for this instrument driver. 
        /// If the Reset parameter is set to TRUE, this function resets the instrument to a known state. 
        /// Sends initialization commands to set the instrument to the state necessary for the operation of the instrument driver. 
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls. 
        /// 
        /// Note:  This function creates a new session the first time you invoke it for a device. If you call niDMM_Initialize on the same resource, the original session is returned. You can use the same session in multiple program threads. You can use the niDMM_LockSession and niDMM_UnlockSession functions to protect sections of code that require exclusive access to the resource.
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Contains the resource name of the device to initialize. 
        /// 
        /// Valid Syntax: 
        /// 
        /// -NI-DAQmx name 
        /// -DAQ::NI-DAQmx name[::INSTR] 
        /// -DAQ::Traditional NI-DAQ device number[::INSTR] 
        /// -IVI logical name  
        /// 
        /// Caution  All IVI names for the Resource Name, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="ID__Query">
        /// Specifies whether the driver performs an ID query. When this parameter is set to VI_TRUE, the driver verifies that the instrument is of a type that this driver supports. 
        /// 
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// VI_TRUE (1) - Perform ID Query (default) 
        /// VI_FALSE (0) - Skip ID Query 
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the instrument during the initialization procedure. 
        /// 
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// VI_TRUE (1) - Reset Device (default) 
        /// VI_FALSE (0) - Don't Reset
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public niDMM(string Resource_Name, bool ID__Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID__Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// 
        /// Creates a new IVI instrument driver session and, optionally, sets the initial state of the following session attributes: 
        /// RangeCheck 
        /// 
        /// QueryInstrStatus 
        /// Cache 
        /// Simulate 
        /// RecordCoersions
        /// 
        /// Opens a session to the device you specify for the Instrument Decriptor parameter. If the ID Query parameter is set to TRUE, this function queries the instrument ID and checks that it is valid for this instrument driver. 
        /// If the Reset parameter is set to TRUE, this function resets the instrument to a known state. Sends initialization commands to set the instrument to the state necessary for the operation of the instrument driver. 
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        /// 
        /// Note  This function creates a new session the first time you invoke it for a device. If you call niDMM_Initialize on the same resource, the original session is returned. You can use the same session in multiple program threads. You can use the niDMM_LockSession and niDMM_UnlockSession functions to protect sections of code that require exclusive access to the resource.
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Contains the resource name of the device to initialize. 
        /// Valid Syntax: 
        /// 
        /// -NI-DAQmx name 
        /// -DAQ::NI-DAQmx name[::INSTR] 
        /// -DAQ::Traditional NI-DAQ device number[::INSTR] 
        /// -IVI logical name  
        /// 
        /// Caution  All IVI names for the Resource Name, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name. 
        /// </param>
        /// <param name="ID__Query">
        /// Specifies whether the driver performs an ID query. When this parameter is set to VI_TRUE, the driver verifies that the instrument is of a type that this driver supports. 
        /// 
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// VI_TRUE (1) - Perform ID Query (default) 
        /// VI_FALSE (0) - Skip ID Query 
        /// 
        /// 
        /// </param>
        /// <param name="Reset_Device">
        /// Specifies whether to reset the instrument during the initialization procedure. 
        /// 
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// VI_TRUE (1) - Reset Device (default) 
        /// VI_FALSE (0) - Don't Reset
        /// 
        /// 
        /// </param>
        /// <param name="Option_String">
        /// Sets the initial value of certain attributes for the session. The following list specifies the attribute name, attribute constant, and default value, respectively, for each attribute that you can use in this parameter: 
        /// 
        /// Check, NIDMM_ATTR_RANGE_CHECK, VI_TRUE
        /// QueryInstrStatus, NIMM_ATTR_QUERY_INSTR_STATUS, VI_FALSE
        /// Cache, NIDMM_ATTR_CACHE, VI_TRUE
        /// Simulate, NIDMM_ATTR_SIMULATE, VI_FALSE
        /// RecordCoercions, NIDMM_ATTR_RECORD_COERCIONS, VI_FALSE
        /// DriverSetup, NIDMM_ATTR_DRIVER_SETUP, "" (empty string)
        /// 
        /// 
        /// 
        /// The format of this string is, "AttributeName=Value." To set multiple attributes, separate their assignments with a comma. 
        /// 
        /// If you pass NULL or an empty string for this parameter, the session uses the default values for the attributes. You can override the default values by assigning a value explicitly in an option string parameter. You do not have to specify all of the attributes and may leave any of them out (those left out use the default value).
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public niDMM(string Resource_Name, bool ID__Query, bool Reset_Device, string Option_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID__Query), System.Convert.ToUInt16(Reset_Device), Option_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this VI. Available only on the NI 4070. If the calibration password is valid, the following operations will be performed:
        /// 
        /// 
        /// Creates a new session for external calibration to the device you specify for the Instrument Descriptor parameter. 
        /// Resets the device and prepares the EEPROM for new calibration coefficients. 
        /// Returns a ViSession handle that you use to identify the instrument in all calibration adjustments and post-adjustment verification steps. 
        /// 
        /// Note: This function creates a new session the first time you invoke it for a device. If you call niDMM_InitExtCal on the same resource, an error is returned. You should use niDMM_CloseExtCal to close a session obtained using niDMM_InitExtCal.
        /// 
        /// After opening a calibration session, the device cannot take valid measurements using this session until the device has been properly adjusted. Once the adjustment phase is complete, you can use this session to verify the new calibration constants. After verification, you have the option of saving the new calibration constants or reverting to the previous calibration constants by specifying the Action parameter in niDMM_CloseExtCal. If you encounter a fatal error such as a power failure or system crash while performing an external calibration, you can call niDMM_RestoreLastExtCalConstants to return the device to a usable state.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// Contains the resource name of the device to initialize. 
        /// 
        /// 
        /// Valid Syntax: "DAQ::device number[::INSTR]" 
        /// 
        /// The default value is "DAQ::1::INSTR"
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Calibration_Password">
        /// Specifies the password required to enable external calibration functionality. 
        /// 
        /// 
        /// The maximum password string length is eight characters, excluding the termination character. "NI" is the factory-defaut password.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Instrument_Handle">
        /// Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls. This special calibration handle is required when making External Calibration function calls. Some of the Calibration Utility function calls are not allowed with a calibration handle. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        public niDMM(string Resource_Name, string Calibration_Password)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Calibration_Password, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }
        
        /// <summary>
        /// Configures the common attributes of the measurement. These attributes include the measurement function, maximum range, and absolute resolution.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Measurement_Function">
        /// Specifies the measurement function used to acquire the measurement. The driver sets NIDMM_ATTR_FUNCTION to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_DC_VOLTS - DC Volts 
        /// NIDMM_VAL_AC_VOLTS - AC Volts 
        /// NIDMM_VAL_DC_CURRENT - DC Current 
        /// NIDMM_VAL_AC_CURRENT - AC Current 
        /// NIDMM_VAL_2_WIRE_RES - 2-Wire Resistance 
        /// NIDMM_VAL_4_WIRE_RES - 4-Wire Resistance 
        /// NIDMM_VAL_FREQ - Frequency 
        /// NIDMM_VAL_PERIOD - Period 
        /// NIDMM_VAL_DIODE - Diode 
        /// NIDMM_VAL_ACVOLTS_DCCOUPLED - AC Volts with DC Coupling
        /// 
        /// The default value is DC volts.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// Specify the range for the measurement. Sets the range for the function specified in the Function control. When frequency is specified in the Function control, you must supply the minimum frequency expected in the Range control. For example, you must type in 100 Hz if you are measuring 101 Hz or higher. For all other functions, you must supply a range that exceeds the value that you are measuring. For example, you must type in 10 V if you are measuring 9 V. Range values are coerced up to the closest input range. Refer to the Device Overview in NI Digital Multimeters Help for a list of valid ranges. The driver sets the NIDMM_ATTR_RANGE attribute to this value. (default 0.02 V) 
        /// 
//
        /// For valid ranges, refer to the device overview for your DMM in the NI Digital Mulitmeters Help. 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ON (-1.0) - Autorange On: NI-DMM performs an autorange before acquiring the measurement.
        /// NIDMM_VAL_AUTO_RANGE_OFF (-2.0) - Autorange Off: NI-DMM uses the current autorange value for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ONCE (-3.0) - Autorange Once: NI-DMM performs an autorange before acquiring the measurement. The autorange value is stored and used for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// </param>
        /// <param name="Resolution">
        /// Specifies the absolute resolution for the measurement. NI-DMM sets NIDMM_ATTR_RESOLUTION_ABSOLUTE to this value. (default 0.001) 
        /// 
        /// 
        /// Note  This parameter is ignored when the Range parameter is set to AutoRange On or AutoRange Once.
        /// 
        /// The default value is 0.001 V.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureMeasurement(int Measurement_Function, System.Double Range, System.Double Resolution)
        {
            int pInvokeResult = PInvoke.ConfigureMeasurement(this._handle, Measurement_Function, Range, Resolution);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the attributes for multipoint measurements. These attributes include the Trigger Count, Sample Count, Sample Trigger, and Sample Interval. For continuous acquisitions, set Trigger Count or Sample Count to zero. For more information, refer to Multiple Point Acquisitions in the NI Digital Multimeters Help.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Trigger_Count">
        /// Sets the number of triggers that you want the DMM to receive before returning to the Idle state. NI-DMM sets NIDMM_ATTR_TRIGGER_COUNT to this value. 
        /// 
        /// 
        /// The default value is 1. 
        /// 
        /// Note  NIDMM_VAL_TRIG_COUNT_INFINITE configures the DMM for a continuous acquistion that must be terminated with niDMM_Abort.
        /// 
        /// 
        /// </param>
        /// <param name="Sample_Count">
        /// Specifies the number of measurements the DMM takes each time it receives a trigger in a multipoint acquisition. NI-DMM sets NIDMM_ATTR_SAMPLE_COUNT to this value. 
        /// 
        /// 
        /// The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Sample_Trigger">
        /// Specifies the sample trigger source. NI-DMM sets NIDMM_ATTR_SAMPLE_TRIGGER to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIMMEDIATE None (default) 
        /// EXTERNAL Pin 9 on the AUX Connector 
        /// SOFTWARE Software Trigger 
        /// INTERVAL Interval Trigger 
        /// TTL0 PXI Trigger Line 0 or RTSI Connector Line 0 
        /// TTL1 PXI Trigger Line 1 or RTSI Connector Line 1 
        /// TTL2 PXI Trigger Line 2 or RTSI Connector Line 2 
        /// TTL3 PXI Trigger Line 3 
        /// TTL4 PXI Trigger Line 4 
        /// TTL5 PXI Trigger Line 5 
        /// TTL6 PXI Trigger Line 6 
        /// TTL7 PXI Trigger Line 7 (NI PXI-4070 only) 
        /// LBR_TRIG0 Local Bus Right Trigger Line 0 of 
        /// PXI/SCXI combination chassis (NI 4070 only) 
        /// AUX TRIG 1 Pin 3 on the AUX Connector 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Sample_Interval">
        /// Sets the amount of time in seconds the DMM waits between measurements. The driver sets NIDMM_ATTR_SAMPLE_INTERVAL to this value. Specify a sample interval to add settling time between measurements or to decrease the measurement rate. Sample Interval only applies when the Sample Trigger is set to Interval. 
        /// 
        /// 
        /// On the NI 4060, the SampleInterval value is used as the settling time. When sample interval is set to 0, the DMM does not settle between measurements. 
        /// 
        /// The NI 4070 uses the value specified in SampleInterval as additional delay. 
        /// 
        /// The default value (-1) ensures that the DMM settles for a recommended time. Using this parameter is the same as using an Immediate trigger. 
        /// 
        /// Note  This attribute is not used for the NI 4050.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureMultiPoint(int Trigger_Count, int Sample_Count, int Sample_Trigger, System.Double Sample_Interval)
        {
            int pInvokeResult = PInvoke.ConfigureMultiPoint(this._handle, Trigger_Count, Sample_Count, Sample_Trigger, Sample_Interval);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the NI 4070 for a waveform acquisition. This function only works with the NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Measurement_Function">
        /// Specifies the measurement function used in a waveform acquisition. The driver sets NIDMM_ATTR_FUNCTION to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_WAVEFORM_VOLTS - Voltage Waveform 
        /// NIDMM_VAL_WAVEFORM_CURRENT - Current Waveform
        /// 
        /// The default value is NIDMM_VAL_WAVEFORM_VOLTS.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// Specifies the expected maximum amplitude of the input signal. Sets the range for measurement function. NI-DMM sets NIDMM_ATTR_RANGE to this value. Range values are coerced up to the closest input range (default 10.0). 
        /// 
        /// 
        /// For valid ranges, refer to the device overview for the NI 4070 in the NI Digital Mulitmeters Help. 
        /// 
        /// Auto-ranging is not supported during waveform acquisitions.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Rate">
        /// Specifies the rate of the acquisition in samples per second. NI-DMM sets NIDMM_ATTR_WAVEFORM_RATE attribute to this value. 
        /// 
        /// 
        /// Valid Range: 10.0 - 1800000.0 S/s. Rate values are coerced to the closest integer divisor of 1800000. 
        /// 
        /// The default value is 1800000.0 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Points">
        /// Specifies the number of points to acquire before the waveform acquisition completes. NI-DMM sets NIDMM_ATTR_WAVEFORM_POINTS attribute to this value. To calculate the maximum and minimum number of waveform points that you can acquire in one acquisition, refer to the NI 4070 Waveform Acquisition Measurement Cycle section. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureWaveformAcquisition(int Measurement_Function, System.Double Range, System.Double Rate, int Waveform_Points)
        {
            int pInvokeResult = PInvoke.ConfigureWaveformAcquisition(this._handle, Measurement_Function, Range, Rate, Waveform_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the powerline frequency. The NI 4060 and NI 4050 use this value to select an aperture time to reject power line noise. The NI 4070 accounts for both 50 Hz and 60 Hz noise automatically. The powerline frequency is used when specifying the aperture in powerline cycles (PLC).
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Power_Line_Frequency">
        /// Specifies the powerline frequency in hertz. NI-DMM sets NIDMM_ATTR_POWERLINE_FREQ to this value. 
        /// 
        /// 
        /// Note:   Set this control to the frequency of the AC powerline. For a 400 Hz powerline, use the 50 Hz setting.
        /// 
        /// The default value is 60 Hz.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigurePowerLineFrequency(System.Double Power_Line_Frequency)
        {
            int pInvokeResult = PInvoke.ConfigurePowerLineFrequency(this._handle, Power_Line_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// When Auto Zero is On, the DMM internally disconnects the input signal and takes a zero reading. It then subtracts the zero reading from the measurement. This action prevents offset voltages present on the input circuitry of the DMM from affecting measurement accuracy. When Auto Zero is Off, the DMM does not compensate for zero reading offset. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Auto_Zero_Mode">
        /// Specifies the Auto Zero mode. NI-DMM sets NIDMM_ATTR_AUTO_ZERO to this value. 
        /// 
        /// 
        /// On enables Auto Zero for each measurement. Once enables Auto Zero before the next measurement. The Auto Zero value is stored and used in subsequent measurements until the device is reconfigured. Off disables Auto Zero. If you set the Auto Zero mode to Auto, the default value, the driver determines whether to enable Auto Zero based on the measurement function that you configure. 
        /// 
        /// If you configure the NI 4070 for a DC measurement with an absolute resolution that corresponds to 6 1/2 digits, the driver sets Auto Zero On. For all other DC measurement configurations on the NI 4070, the driver sets Auto Zero Once. For all AC measurements and waveform acquisition on the NI 4070, the driver sets AutoZero to Off. For NI 4050/4060 measurements, Auto Zero is set to Off when Auto is selected.
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// NIDMM_VAL_AUTO_ZERO_AUTO (-1) 
        /// NIDMM_VAL_AUTO_ZERO_OFF (0) 
        /// NIDMM_VAL_AUTO_ZERO_ON (1) 
        /// NIDMM_VAL_AUTO_ZERO_ONCE (2)
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureAutoZeroMode(int Auto_Zero_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureAutoZeroMode(this._handle, Auto_Zero_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Allows the DMM to compensate for gain drift since the last external calibration or self-calibration. When ADC Calibration is On, the DMM measures an internal reference to calculate the correct gain for the measurement. When ADC Calibration is Off, the DMM does not compensate for changes to the gain. 
        /// 
        /// Available only for NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="ADC__Calibration">
        /// Specifies the ADC Calibration setting. NI-DMM sets NIDMM_ATTR_ADC_CALIBRATION to this value. 
        /// 
        /// 
        /// On enables ADC Calibration. Off disables ADC Calibration. 
        /// 
        /// If you set the value to Auto, the driver determines whether to enable ADC Calibration based on the measurement function and resolution that you configure. If you configure the NI 4070 for a DC measurement with an absolute resolution that corresponds to 6 1/2 digits, the driver enables ADC Calibration. For all other measurement configurations, the driver disables ADC Calibration.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_ADC_CALIBRATION_AUTO (-1.0) 
        /// NIDMM_VAL_ADC_CALIBRATION_OFF (0) 
        /// NIDMM_VAL_ADC_CALIBRATION_ON (1)
        /// 
        /// The default value is NIDMM_VAL_ADC_CALIBRATION_AUTO.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureADCCalibration(int ADC__Calibration)
        {
            int pInvokeResult = PInvoke.ConfigureADCCalibration(this._handle, ADC__Calibration);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Allows the DMM to compensate for voltage offsets in resistance measurements. When Offset Compensated Ohms is enabled, the DMM measures the resistance twice (once with the current source On and again with it turned Off). Any voltage offset present in both measurements is cancelled out. Offset Compensated Ohms is useful when measuring resistance values less than 10 K ohms. 
        /// 
        /// Available only on the NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Offset_Comp_Ohms">
        /// Enables and disables Offset Compensated Ohms. NI-DMM sets NIDMM_ATTR_OFFSET_COMP_OHMS to this value. On enables Offset Compensated Ohms. Off disables Offset Compensated Ohms. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// NIDMM_VAL_OFFSET_COMP_OHMS_OFF
        /// 
        /// NIDMM_VAL_OFFSET_COMP_OHMS_ON 
        /// 
        /// The default value is Off.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureOffsetCompOhms(int Offset_Comp_Ohms)
        {
            int pInvokeResult = PInvoke.ConfigureOffsetCompOhms(this._handle, Offset_Comp_Ohms);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the AC minimum frequency and AC maximum frequency attributes that the DMM uses for AC measurements.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="AC__Minimum_Frequency_Hz">
        /// Passes the minimum expected frequency component of the input signal in hertz. The driver sets NIDMM_ATTR_AC_MIN_FREQ to this value. This parameter affects the DMM only when you set the Measurement Function parameter to AC measurements. The NI 4070 uses this parameter to calculate the proper aperture for the measurement. 
        /// 
        /// 
        /// Note  On NI 4050 and NI 4060 boards this parameter is ignored.
        /// 
        /// Valid Range: 20.0 - 25000.0 Hz 
        /// 
        /// The default value is 20.0 Hz.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="AC__Maximum_Frequency_Hz">
        /// Specifies the maximum expected frequency component of the input signal in hertz. This parameter effects the DMM only when you set the Measurement Function parameter to AC measurements. The driver sets the NIDMM_ATTR_AC_MAX_FREQ attribute to this value. 
        /// 
        /// 
        /// Note  This parameter is currently ignored.
        /// 
        /// The default value is 25,000.0 Hz.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureACBandwidth(System.Double AC__Minimum_Frequency_Hz, System.Double AC__Maximum_Frequency_Hz)
        {
            int pInvokeResult = PInvoke.ConfigureACBandwidth(this._handle, AC__Minimum_Frequency_Hz, AC__Maximum_Frequency_Hz);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Specifies the expected maximum amplitude of the input signal for frequency and period measurements.
        /// 
        /// Available for the NI 4070 only.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Voltage_Range">
        /// Specifies the expected maximum AC rms value of the input signal. The driver sets the NIDMM_ATTR_FREQ_VOLTAGE_RANGE attribute to this value. 
        /// 
        /// 
        /// The minimum peak-to-peak signal amplitude that can be detected is 10% of the specified voltage range. Refer to the NI 4070 Functional Overview in the NI Digital Multimeters Help for a list of valid values.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_AUTO_RANGE_ON (-1.0) - Configures the DMM to take an Auto Range measurement to calculate the voltage range before each frequency or period measurement. 
        /// NIDMM_VAL_AUTO_RANGE_OFF (-2.0) - Disables Auto Ranging. The driver sets the voltage range to the last calculated voltage range. 
        /// NIDMM_VAL_AUTO_RANGE_ONCE (-3.0) - Autorange Once: NI-DMM performs an autorange before acquiring the measurement. The autorange value is stored and used for all subsequent measurements until the measurement configuration is changed.
        /// 
        /// The default value is Auto Range On.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureFrequencyVoltageRange(System.Double Voltage_Range)
        {
            int pInvokeResult = PInvoke.ConfigureFrequencyVoltageRange(this._handle, Voltage_Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the current source for diode measurements. 
        /// 
        /// Available only for the NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Current_Source">
        /// Specifies the current source provided during diode measurements. NI-DMM sets NIDMM_ATTR_CURRENT_SOURCE to this value. 
        /// 
        /// 
        /// The default value is 1 mA. 
        /// 
        /// For valid values on the NI 4070, refer to the NI PXI-4070 Functional Overview in the NI Digital Multimeters Help.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureCurrentSource(System.Double Current_Source)
        {
            int pInvokeResult = PInvoke.ConfigureCurrentSource(this._handle, Current_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Specifies how the DMM couples the voltage waveform input signal. 
        /// 
        /// Available for the NI 4070 only.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Waveform_Coupling">
        /// Specifies DC or AC coupling. NI-DMM sets NIDMM_ATTR_WAVEFORM_COUPLING to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// NIDMM_VAL_WAVEFORM_COUPLING_AC
        /// 
        /// NIDMM_VAL_WAVEFORM_COUPLING_DC 
        /// 
        /// The default value is NIDMM_VAL_WAVEFORM_COUPLING_DC.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureWaveformCoupling(int Waveform_Coupling)
        {
            int pInvokeResult = PInvoke.ConfigureWaveformCoupling(this._handle, Waveform_Coupling);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Configures the DMM trigger source and trigger delay. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Trigger_Source">
        /// Specifies the trigger source that initiates the acquisition. NI-DMM sets NIDMM_ATTR_TRIGGER_SOURCE to this value. 
        /// 
        /// 
        /// When Trigger Source is set to Immediate, the DMM does not wait for a trigger. TTLn configures the DMM to wait for a digital edge trigger on the corresponding PXI trigger line. External configures the DMM to wait for a digital edge trigger on the 9-pin AUX connector of the DMM. The NI 4070 can receive a trigger on the local bus backplane in combination PXI/SCXI chassis such as the PXI-1010 and PXI-1011. The NI 4070 must be in the rightmost slot of the combo chassis in order to receive a trigger on LBR_TRIG_1. Software configures the DMM to wait until niDMM_SendSoftwareTrigger is called to trigger the DMM.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// IMMEDIATE None (default) 
        /// EXTERNAL Pin 9 on the AUX Connector 
        /// SOFTWARE Software Trigger 
        /// INTERVAL Interval Trigger 
        /// TTL0 PXI Trigger Line 0 or RTSI Connector Line 0 
        /// TTL1 PXI Trigger Line 1 or RTSI Connector Line 1 
        /// TTL2 PXI Trigger Line 2 or RTSI Connector Line 2 
        /// TTL3 PXI Trigger Line 3 
        /// TTL4 PXI Trigger Line 4 
        /// TTL5 PXI Trigger Line 5 
        /// TTL6 PXI Trigger Line 6 
        /// TTL7 PXI Trigger Line 7 (NI PXI-4070 only) 
        /// LBR_TRIG0 Local Bus Right Trigger Line 0 of 
        /// PXI/SCXI combination chassis (NI 4070 only) 
        /// AUX TRIG 1 Pin 3 on the AUX Connector 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Trigger_Delay">
        /// Specifies the time that the DMM waits after it has received a Trigger before it takes a measurement. NI-DMM sets NIDMM_ATTR_TRIGGER_DELAY to this value. The default value is NIDMM_VAL_AUTO_DELAY (-1), which means the DMM waits an appropriate settling time before taking the measurement. 
        /// 
        /// 
        /// On the NI 4060, if you set Trigger Delay to 0, the DMM does not settle before taking the measurement. 
        /// 
        /// The NI 4070 uses the value specified in Trigger Delay as additional settling time.
        /// 
        /// The valid range is 0.0 - 12.0 (seconds).
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureTrigger(int Trigger_Source, System.Double Trigger_Delay)
        {
            int pInvokeResult = PInvoke.ConfigureTrigger(this._handle, Trigger_Source, Trigger_Delay);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sends a command to trigger the DMM. Call this function if you have configured either the Trigger Source or Sample Trigger Source to Software. If Trigger and/or Sample Trigger sources are set to External or TTLn, you can use this function to override the trigger source that you configured and trigger the NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int SendSoftwareTrigger()
        {
            int pInvokeResult = PInvoke.SendSoftwareTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Specifies the destination of the DMM Measurement Complete (MC) signal. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Meas_Complete_Destination">
        /// Specifies the destination of the Measurement Complete signal. The device issues this signal the DMM completes a single measurement. NI-DMM sets the NIDMM_ATTR_MEAS_COMPLETE_DEST attribute to this value. 
        /// 
        /// 
        /// Note:   This signal is commonly referred to as Voltmeter Complete.
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NONE None (default) 
        /// EXTERNAL 9-pin AUX Connector 
        /// TTL0 PXI Trigger Line 0 or RTSI Connector Line 0 
        /// TTL1 PXI Trigger Line 1 or RTSI Connector Line 1 
        /// TTL2 PXI Trigger Line 2 or RTSI Connector Line 2 
        /// TTL3 PXI Trigger Line 3 
        /// TTL4 PXI Trigger Line 4 
        /// TTL5 PXI Trigger Line 5 
        /// TTL6 PXI Trigger Line 6 
        /// TTL7 PXI Trigger Line 7 (NI PXI-4070 only) 
        /// LBR TRIG0 Local Bus Right Trigger Line 0 of 
        /// PXI/SCXI combination chassis (NI PXI-4070 only) 
        /// 
        /// 
        /// Note  The NI PXI-4060 in the rightmost slot of a combination chassis can generate MC on the internal trigger lines by specifying TTL0.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureMeasCompleteDest(int Meas_Complete_Destination)
        {
            int pInvokeResult = PInvoke.ConfigureMeasCompleteDest(this._handle, Meas_Complete_Destination);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the Trigger Slope to either Rising Edge (positive) or Falling Edge (negative).
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Trigger_Slope">
        /// Specifies the edge of the signal on which the measurement is triggered. NI-DMM sets NIDMM_ATTR_TRIGGER_SLOPE to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// NIDMM_VAL_POSITIVE - The driver triggers on the rising edge of the trigger signal. 
        /// NIDMM_VAL_NEGATIVE - The driver triggers on the falling edge of the trigger signal.
        /// The default value is Negative.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureTriggerSlope(int Trigger_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerSlope(this._handle, Trigger_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the Sample Trigger Slope to either Rising Edge (positive) or Falling Edge (negative).
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Sample_Trigger_Slope">
        /// Specifies the edge of the signal on which the measurement is triggered. NI-DMM sets NIDMM_ATTR_SAMPLE_TRIGGER_SLOPE to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_VAL_POSITIVE - The driver triggers on the rising edge of the trigger signal. 
        /// NIDMM_VAL_NEGATIVE - The driver triggers on the falling edge of the trigger signal.
        /// 
        /// The default value is Negative.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSampleTriggerSlope(int Sample_Trigger_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureSampleTriggerSlope(this._handle, Sample_Trigger_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Sets the Measurement Complete Signal Slope to either Rising Edge (positive) or Falling Edge (negative) polarity.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Meas_Complete_Slope">
        /// Specifies the polarity of the signal that is generated. NI-DMM sets NIDMM_ATTR_MEAS_DEST_SLOPE to this value. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// 
        /// NIDMM_VAL_POSITIVE
        /// 
        /// NIDMM_VAL_NEGATIVE (default) 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureMeasCompleteSlope(int Meas_Complete_Slope)
        {
            int pInvokeResult = PInvoke.ConfigureMeasCompleteSlope(this._handle, Meas_Complete_Slope);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the actual range that the DMM is using, even when Autorange is Off.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Actual_Range">
        /// Returns the value of NIDMM_ATTR_AUTO_RANGE_VALUE. The units of the returned value depend on the value of NIDMM_ATTR_FUNCTION. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetAutoRangeValue(out System.Double Actual_Range)
        {
            int pInvokeResult = PInvoke.GetAutoRangeValue(this._handle, out Actual_Range);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the DMM aperture time and aperture time units.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Aperture_Time">
        /// Returns the value of NIDMM_ATTR_APERTURE_TIME. The units of this attribute depend on the value of NIDMM_ATTR_APERTURE_TIME_UNITS. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Aperture_Time_Units">
        /// Indicates the units of aperture time as powerline cycles (PLCs) or seconds. Returns the value of NIDMM_ATTR_APERTURE_TIME_UNITS. 
        /// 
        /// 
        /// Defined Return Values: 
        /// 
        /// 
        /// NIDMM_VAL_SECONDS - Seconds 
        /// NIDMM_VAL_POWER_LINE_CYCLES - Powerline cycles 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetApertureTimeInfo(out System.Double Aperture_Time, out int Aperture_Time_Units)
        {
            int pInvokeResult = PInvoke.GetApertureTimeInfo(this._handle, out Aperture_Time, out Aperture_Time_Units);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the calculated measurement period, which is the amount of time it takes to complete one measurement with the current configuration.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Period">
        /// Returns the number of seconds it takes to make one measurement. 
        /// 
        /// 
        /// The first measurement in a multipoint acquisition requires additional settle time. niDMM_GetMeasurementPeriod does not include this additional time or any Trigger Delay associated with the first measurement. Time required for internal measurements, such as AutoZero, are included.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetMeasurementPeriod(out System.Double Period)
        {
            int pInvokeResult = PInvoke.GetMeasurementPeriod(this._handle, out Period);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Acquires a single measurement and returns the measured value.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading">
        /// The measured value returned from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int Read(int Maximum_Time, out System.Double Reading)
        {
            int pInvokeResult = PInvoke.Read(this._handle, Maximum_Time, out Reading);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Acquires multiple measurements and returns an array of measured values. The number of measurements the DMM makes is determined by the values you specify for the Trigger Count and Sample Count parameters in niDMM_ConfigureMultiPoint.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// Specifies the number of measurements to acquire. The total number of measurements for a finite acquisition is TriggerCount times SampleCount. The number of measurements can be a subset. 
        /// 
        /// 
        /// The valid range is any positive ViInt32. 
        /// 
        /// The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading_Array">
        /// An array of measurement values. 
        /// 
        /// 
        /// Note:   The size of the Reading Array must be at least the size that you specify for the Array Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// Indicates the number of measured values actually retrieved from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ReadMultiPoint(int Maximum_Time, int Array_Size, System.Double[] Reading_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.ReadMultiPoint(this._handle, Maximum_Time, Array_Size, Reading_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Acquires a waveform and returns an array representing the digitized waveform. The number of elements in the waveform array is determined by the value you specify for the WaveformPoints parameter in niDMM_ConfigureWaveformAcquisition.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// Specifies the number of waveform points to return. You specify the total number of points that the DMM acquires in the WaveformPoints parameter of the niDMM_ConfigureWaveformAcquisition function. 
        /// 
        /// 
        /// The valid range is any positive ViInt32. 
        /// 
        /// The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Array">
        /// An array of measurement values. 
        /// 
        /// 
        /// Note:   The size of the Waveform Array must be at least the size that you specify for the Array Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// Indicates the number of measured values actually retrieved from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ReadWaveform(int Maximum_Time, int Array_Size, System.Double[] Waveform_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.ReadWaveform(this._handle, Maximum_Time, Array_Size, Waveform_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Takes a measurement value and determines if the value is a valid measurement or a value indicating that an overrange condition occured. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Measurement_Value">
        /// The measured value returned from niDMM_Read or niDMM_Fetch. 
        /// 
        /// 
        /// Note:   If an overrange condition occurs, the measurement value contains an IEEE-defined NaN (Not a Number) value.
        /// 
        /// 
        /// </param>
        /// <param name="Is_Over_Range">
        /// Returns whether the measurement value is a valid measurement or an overrange condition. 
        /// 
        /// 
        /// Defined Values: 
        /// 
        /// 
        /// VI_TRUE (1) - The value indicates that an overrange condition occurred. 
        /// VI_FALSE (0) - The value is a valid measurement. 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int IsOverRange(System.Double Measurement_Value, out bool Is_Over_Range)
        {
            System.UInt16 Is_Over_RangeAsUShort;
            int pInvokeResult = PInvoke.IsOverRange(this._handle, Measurement_Value, out Is_Over_RangeAsUShort);
            Is_Over_Range = System.Convert.ToBoolean(Is_Over_RangeAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function initiates an acquisition. After you call this function, the DMM leaves the Idle state and enters the Wait for Trigger state. Use niDMM_Fetch, niDMM_FetchMultipoint, or niDMM_FetchWaveform to retrieve the measurement data.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int Initiate()
        {
            int pInvokeResult = PInvoke.Initiate(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the value from a previously initiated measurement. You must first call niDMM_Initiate to initiate a measurement before calling niDMM_Fetch.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading">
        /// The measured value returned from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int Fetch(int Maximum_Time, out System.Double Reading)
        {
            int pInvokeResult = PInvoke.Fetch(this._handle, Maximum_Time, out Reading);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns an array of values from a previously initiated multipoint measurement. 
        /// 
        /// The number of measurements the DMM makes is determined by the values you specify for the Trigger Count and Sample Count parameters of niDMM_ConfigureMultiPoint. You must first call niDMM_Initiate to initiate a measurement before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// Specifies the number of measurements to return. The total number of measurements for a finite acquisition is TriggerCount times SampleCount. For continuous acquisitions, up to 100,000 points can be returned at once. 
        /// 
        /// 
        /// The valid range is any positive ViInt32. 
        /// 
        /// The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Reading_Array">
        /// An array of measurement values. 
        /// 
        /// 
        /// Note:   The size of the Reading Array must be at least the size that you specify for the Array Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// Indicates the number of measured values actually retrieved from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int FetchMultiPoint(int Maximum_Time, int Array_Size, System.Double[] Reading_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.FetchMultiPoint(this._handle, Maximum_Time, Array_Size, Reading_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns an array of values from a previously initiated waveform acquisition. You must first call niDMM_Initiate before calling this function. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Maximum_Time">
        /// Specifies the maximum time allowed for this function to complete in milliseconds. If the function does not complete within this time interval, the function returns the NIDMM_ERROR_MAX_TIME_EXCEEDED error code. This may happen if an external trigger has not been received, or if the specified timeout is not long enough for an acquisition to complete. 
        /// 
        /// 
        /// The valid range is 0 - 86400000. 
        /// 
        /// The default value is NIDMM_VAL_TIME_LIMIT_AUTO (-1). The DMM calculates the timeout automatically. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Array_Size">
        /// Specifies the number of waveform points to return. You specify the total number of points that the DMM acquires in the WaveformPoints parameter of the niDMM_ConfigureWaveformAcquisition function. 
        /// 
        /// 
        /// The valid range is any positive ViInt32. 
        /// 
        /// The default value is 1.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Waveform_Array">
        /// An array of measurement values. 
        /// 
        /// 
        /// Note:   The size of the Waveform Array must be at least the size that you specify for the Array Size parameter.
        /// 
        /// 
        /// </param>
        /// <param name="Actual_Number_Of_Points">
        /// Indicates the number of measured values actually retrieved from the DMM. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError and niDMM_ClearError.
        /// 
        /// 
        /// 
        /// </returns>
        public int FetchWaveform(int Maximum_Time, int Array_Size, System.Double[] Waveform_Array, out int Actual_Number_Of_Points)
        {
            int pInvokeResult = PInvoke.FetchWaveform(this._handle, Maximum_Time, Array_Size, Waveform_Array, out Actual_Number_Of_Points);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Aborts a previously initiated measurement and returns the DMM to the Idle state.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int Abort()
        {
            int pInvokeResult = PInvoke.Abort(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns backlog and acquisition status. Use this function to determine how many measurements are available before calling niDMM_Fetch, niDMM_FetchMultipoint, or niDMM_FetchWaveform. Available only on the NI 4060 and NI 4070.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Acquisition_Backlog">
        /// The number of measurements available to be read. If the backlog continues to increase, data overflows the internal buffer, resulting in an error. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Acquisition_Status">
        /// Indicates status of the acquisition. 
        /// 
        /// 
        /// Acquisition States: 
        /// 
        /// 
        /// 0: Running 
        /// 1: Finished with backlog 
        /// 2: Finished with no backlog 
        /// 3: Paused 
        /// 4: No acquisition in progress
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ReadStatus(out int Acquisition_Backlog, out short Acquisition_Status)
        {
            int pInvokeResult = PInvoke.ReadStatus(this._handle, out Acquisition_Backlog, out Acquisition_Status);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Runs the NI 4070 self calibration routine. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int SelfCal()
        {
            int pInvokeResult = PInvoke.SelfCal(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this function. Calibrates the gain coefficient for the supplied mode, range, and input resistance.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// Specifies the calibration mode used to acquire the measurement. For valid modes, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure.
        /// 
        /// </param>
        /// <param name="Range">
        /// Specifies the range to calibrate. 
        /// 
        /// 
        /// For valid ranges, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Input_Resistance">
        /// Specifies the input resistance that the device should use. Input resistance values are coerced up to the closest input resistance. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Expected_Value">
        /// Specifies the expected value of the measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustGain(int Mode, System.Double Range, System.Double Input_Resistance, System.Double Expected_Value)
        {
            int pInvokeResult = PInvoke.CalAdjustGain(this._handle, Mode, Range, Input_Resistance, Expected_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this function. Calibrates the offset and Auto Zero offset for the supplied mode, range, and input resistance.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// Specifies the calibration mode used to acquire the measurement. For valid modes, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure.
        /// 
        /// </param>
        /// <param name="Range">
        /// Specifies the range to calibrate. 
        /// 
        /// 
        /// For valid ranges, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Input_Resistance">
        /// Specifies the input resistance that the device should use. Input resistance values are coerced up to the closest input resistance. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustOffset(int Mode, System.Double Range, System.Double Input_Resistance)
        {
            int pInvokeResult = PInvoke.CalAdjustOffset(this._handle, Mode, Range, Input_Resistance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this function. Performs a specialized calibration step depending on the specified type.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Type">
        /// Specifies which one of the miscellaneous calibration steps to perform. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_EXTCAL_MISCCAL_VREF - Calibrate the Voltage Reference. (default) 
        /// NIDMM_EXTCAL_MISCCAL_RREF - Calibrate the Resistance Reference. 
        /// NIDMM_EXTCAL_MISCCAL_ZINT - Calibrate the Internal Impedance. 
        /// NIDMM_EXTCAL_MISCCAL_2WIRELEAKAGE - Calibrate the 2-wire Leakage resistance. 
        /// NIDMM_EXTCAL_MISCCAL_4WIRELEAKAGE - Calibrate the 4-wire Leakage resistance. 
        /// NIDMM_EXTCAL_MISCCAL_SECTION - Update calibration information and verify calibration completeness.
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustMisc(int Type)
        {
            int pInvokeResult = PInvoke.CalAdjustMisc(this._handle, Type);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this function. Calibrates the filter coefficients used for AC measurements of the supplied mode and range.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Mode">
        /// Specifies the calibration mode used to acquire the measurement. For valid modes, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure.
        /// 
        /// </param>
        /// <param name="Range">
        /// Specifies the range to calibrate. 
        /// 
        /// 
        /// For valid ranges, refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure. Auto-ranging is not supported for calibration operations.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Frequency">
        /// Specifies the frequency of the input signal. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Expected_Value">
        /// Specifies the expected value of the measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustACFilter(int Mode, System.Double Range, System.Double Frequency, System.Double Expected_Value)
        {
            int pInvokeResult = PInvoke.CalAdjustACFilter(this._handle, Mode, Range, Frequency, Expected_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Refer to the NI PXI-4070 6 1/2 Digit FlexDMM Calibration Procedure before using this function. This function is for the NI 4070 only. Performs the specified action, closes the specified external calibration session obtained from niDMM_InitExtCal, and deallocates resources that it reserved.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_InitExtCal. The handle identifies a particular instrument calibration session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Action">
        /// Specifies whether the driver saves the updated calibration constants. When this parameter is set to NIDMM_EXTCAL_ACTION_SAVE, the driver stores the new calibration constants. 
        /// 
        /// 
        /// Defined Values:
        /// 
        /// 
        /// NIDMM_EXTCAL_ACTION_ABORT - Restore the calibration constants to what they were before starting the external calibration procedure. (default) 
        /// NIDMM_EXTCAL_ACTION_SAVE - Save the new calibration constants to the device.
        /// 
        /// These constants are used for any subsequent measurements.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int CloseExtCal(int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(this._handle, Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the calibration count for the specified type of calibration.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// Specifies the type of calibration. 
        /// Defined Values: 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA - Self Calibration (default)
        /// NIDMM_VAL_EXTERNAL_AREA - External Calibration
        /// 
        /// 
        /// </param>
        /// <param name="Count">
        /// The number of times calibration has been performed. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalCount(int Cal_Type, out int Count)
        {
            int pInvokeResult = PInvoke.GetCalCount(this._handle, Cal_Type, out Count);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the date and time of the last calibration.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// Specifies the type of calibration. 
        /// Defined Values: 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA - Self Calibration (default)
        /// NIDMM_VAL_EXTERNAL_AREA - External Calibration
        /// 
        /// 
        /// </param>
        /// <param name="Month">
        /// Indicates the month of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Day">
        /// Indicates the day of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Year">
        /// Indicates the year of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Hour">
        /// Indicates the hour of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Minute">
        /// Indicates the minute of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalDateAndTime(int Cal_Type, out int Month, out int Day, out int Year, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetCalDateAndTime(this._handle, Cal_Type, out Month, out Day, out Year, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the current temperature of the device. 
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Options">
        /// Reserved. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Temperature">
        /// Returns the current temperature value of the device. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetDevTemp(string Options, out System.Double Temperature)
        {
            int pInvokeResult = PInvoke.GetDevTemp(this._handle, Options, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the temperature during the last calibration procedure. 
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Cal_Type">
        /// Specifies the type of calibration. 
        /// Defined Values: 
        /// 
        /// NIDMM_VAL_INTERNAL_AREA - Self Calibration (default)
        /// NIDMM_VAL_EXTERNAL_AREA - External Calibration
        /// 
        /// 
        /// </param>
        /// <param name="Temperature">
        /// Returns the temperature value at the time of the last calibration. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetLastCalTemp(int Cal_Type, out System.Double Temperature)
        {
            int pInvokeResult = PInvoke.GetLastCalTemp(this._handle, Cal_Type, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the maximum string length that can be stored in the EEPROM. Use niDMM_SetCalUserDefinedInfo to store user-defined information.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Info_Size">
        /// Returns the value of maximum string length that can be stored in the EEPROM using niDMM_SetCalUserDefinedInfo. 
        /// 
        /// 
        /// The Info Size value is given in characters, but it does not include the termination character.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalUserDefinedInfoMaxSize(out int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(this._handle, out Info_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the user-defined calibration information stored in the EEPROM.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Pass the number of bytes in the ViString you specify for the Info parameter. 
        /// 
        /// 
        /// If zero is passed for this parameter, the buffer size needed to store the information is returned. If the Info parameter, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Info">
        /// Returns the user-defined calibration information stored in the EEPROM. 
        /// 
        /// 
        /// If this is NULL, the buffer size needed to store the information is returned.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalUserDefinedInfo(int Buffer_Size, System.Text.StringBuilder Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(this._handle, Buffer_Size, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Stores the user-defined information in the EEPROM.
        /// 
        /// Use niDMM_GetUserDefinedInfoMaxSize to learn the maximum string size that is allowed. If the Info string size is larger than the maximum string size, NI-DMM stores as much of the information as possible (truncating the remainder) and returns a warning.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Info">
        /// Specifies the user-defined information to be stored in the EEPROM such as the operator who performed the calibration operation or system information.. 
        /// 
        /// 
        /// Use niDMM_GetUserDefinedInfoMaxSize to learn the maximum string size that is allowed. If the Info string size is larger than the maximum string size, we will store as much of the information as possible (truncating the remainder) and return a warning.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int SetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the recommended interval between external recalibration in months.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Months">
        /// Returns the recommended number of months between external calibrations. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetExtCalRecommendedInterval(out int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(this._handle, out Months);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Queries the driver to determine if self-calibration (Self Cal) is supported for the device specified by the given session.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Self_Cal_Supported">
        /// Returns whether Self Cal is supported for the device specified by the given session. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetSelfCalSupported(out bool Self_Cal_Supported)
        {
            System.UInt16 Self_Cal_SupportedAsUShort;
            int pInvokeResult = PInvoke.GetSelfCalSupported(this._handle, out Self_Cal_SupportedAsUShort);
            Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Reverts the device to use the calibration constants from the last complete external calibration.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// This function can be used to recover your hardware if a fatal system error should occur during an external or self calibration procedure. After calling this function, it is recommended that you call niDMM_SelfCal before taking measurements with the device to adjust the device for any temperature drifts since the last external calibration.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int RestoreLastExtCalConstants()
        {
            int pInvokeResult = PInvoke.RestoreLastExtCalConstants(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Changes the password required to enable external calibration functionality for the specified instrument. The maximum password string length is eight characters, excluding the termination character. "NI" is the factory-default password.
        /// 
        /// Available only for the NI 4070. 
        /// 
        /// Note:  A password is required for external calibration. Be sure to record the password in a secure location.
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Old_Password">
        /// Specifies the current password required to enable external calibration functionality. 
        /// 
        /// 
        /// The maximum password string length is eight characters, excluding the termination character.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="New_Password">
        /// Specifies the new password required to enable external calibration functionality. 
        /// 
        /// 
        /// The maximum password string length is eight characters, excluding the termination character.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int SetCalPassword(string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.SetCalPassword(this._handle, Old_Password, New_Password);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the instrument to a known state and sends initialization commands to the instrument. The initialization commands set instrument settings to the state necessary for the operation of the instrument driver.
        /// 
        ///  
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Resets the instrument to a known state and sends initialization commands to the instrument. The initialization commands set instrument settings to the state necessary for the operation of the instrument driver. All user-defined default values associated with a logical name are applied after resetting the device.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Performs a self-test routine on the DMM and returns the test result(s). 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Self_Test_Result">
        /// Contains the value returned from the instrument self-test. Zero indicates success. 
        /// 
        /// 
        /// For the NI 4070, a Self_Test_Result code of 1013 most likely indicates that the fuse has been permanently damaged. Please check the fuse and replace it, if necessary.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Self___Test_Message">
        /// This control contains the string returned from the instrument self-test. The array must contain at least 256 elements. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self___Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self___Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the revision numbers of the instrument driver and instrument firmware.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// Returns the instrument driver software revision numbers in the form of a string. 
        /// Note:   The array must contain at least 256 elements ViChar[256]. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Firmware_Revision">
        /// Returns a string containing the instrument firmware revision numbers. 
        /// 
        /// 
        /// Note:   The array must contain at least 256 elements ViChar[256]. 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected. If a measurement is in progress when Disable is called, the measurement is aborted.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the channel string that is in the channel table at an index you specify. Not applicable to National Instruments DMMs. Included for compliance with the IviDmm Class Specification.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Index">
        /// A 1-based index into the channel table. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Passes the number of bytes in the ViChar array you specify for the Interchange Warning parameter. 
        /// 
        /// 
        /// If the next interchangeability warning string, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. 
        /// 
        /// For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        /// 
        /// If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter. 
        /// 
        /// The default value is None.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Channel_String">
        /// Returns the channel string that is in the channel table at the index you specify. Do not modify the contents of the channel string. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetChannelName(int Index, int Buffer_Size, System.Text.StringBuilder Channel_String)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, Buffer_Size, Channel_String);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Returns the digits of precision calculated from the range/resolution information specified in niDMM_ConfigureMeasurement.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Digits">
        /// This indicator shows the digits of precision that correspond to the range/resolution selection made in niDMM_ConfigureMeasurement. Values include 31/2, 41/2, 51/2, and 61/2, where 61/2 is available for the NI 4070 only. 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetDigitsofPrecision(out System.Double Digits)
        {
            int pInvokeResult = PInvoke.GetDigitsofPrecision(this._handle, out Digits);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Reads an error code and message from the DMM error queue. National Instruments DMMs do not contain an error queue. Errors are reported as they occur. Therefore, this function does not detect errors; it is included for compliance with the IviDmm Class Specification.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// The Error Code returned from the instrument. 
        /// 
        /// 
        /// The default value is 0 - VI_SUCCESS.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Error_Message">
        /// Formats the error code into a user-readable message string. 
        /// 
        /// 
        /// Note:   The array must contain at least 256 elements ViChar[256].
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int error_query(out int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.error_query(this._handle, out Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. 
        /// 
        /// Use this function to retrieve interchangeability warnings. The driver performs interchangeability checking when NIDMM_ATTR_INTERCHANGE_CHECK is set to VI_TRUE. The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session. 
        /// 
        /// In general, the instrument driver generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Passes the number of bytes in the ViChar array you specify for the Interchange Warning parameter. 
        /// 
        /// 
        /// If the next interchangeability warning string, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. 
        /// 
        /// For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        /// 
        /// If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter. 
        /// 
        /// The default value is None.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Interchange_Warning">
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Clears the list of current interchange warnings. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order. To do so requires ensuring that each test module completely configures the state of each instrument it uses. 
        /// 
        /// If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module. 
        /// 
        /// If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change. 
        /// 
        /// This change in behavior is generally instrument specific and represents an interchangeability problem. You can use this function to test for such cases. After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations. 
        /// 
        /// By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules. 
        /// 
        /// This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings. If you want to guarantee that niDMM_GetNextInterchangeWarning only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings. 
        /// 
        /// You can clear the interchangeability warnings list by repeatedly calling niDMM_GetNextInterchangeWarning until no more interchangeability warnings are returned. If you are not interested in the content of those warnings, you can call niDMM_ClearInterchangeWarnings.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// This function returns the coercion information associated with the IVI session. This function retrieves and clears the oldest instance in which the instrument driver coerced a value you specified to another value. 
        /// 
        /// If you set NIDMM_ATTR_RECORD_COERCIONS to VI_TRUE, NI-DMM keeps a list of all coercions it makes on ViInt32 or ViReal64 values that you pass to instrument driver functions. Use this function to retrieve information from that list.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Instrument_Handle">
        /// The session handle that you obtain from niDMM_init or niDMM_InitWithOptions. The handle identifies a particular instrument session. 
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// Passes the number of bytes in the ViChar array you specify for the Coercion Record parameter. If the next coercion record string, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. 
        /// 
        /// 
        /// For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        /// 
        /// If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. 
        /// 
        /// The default value is None.
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Coercion_Record">
        /// Returns the next coercion record for the IVI session. 
        /// 
        /// 
        /// If there are no coercions records, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter.
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }
        
        /// <summary>
        /// Formats the measurement to the proper number of displayed digits according to the measurement function, range, and resolution. Returns the formatted data, range, and mode strings. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Measurement_Function">
        /// Specifies the measurement function used to acquire the measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Range">
        /// Species the range for the measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Resolution">
        /// Specifies the absolute resolution of the measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Measurement">
        /// The measured value returned from niDMM_Read or niDMM_Fetch. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Mode_String">
        /// Returns the measurement mode string containing the formatted units of measurement. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Range_String">
        /// Returns the range of the measurement, formatted into a string. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Data_String">
        /// Returns the measurement, formatted with the correct number of digits according to the function, range, and resolution. 
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// Reports the status of this operation. To obtain a text description of the status code, call niDMM_error_message. To obtain additional information concerning the error condition, use niDMM_GetError.
        /// 
        /// 
        /// 
        /// </returns>
        public static int FormatMeasAbsolute(int Measurement_Function, System.Double Range, System.Double Resolution, System.Double Measurement, System.Text.StringBuilder Mode_String, System.Text.StringBuilder Range_String, System.Text.StringBuilder Data_String)
        {
            int pInvokeResult = PInvoke.FormatMeasAbsolute(Measurement_Function, Range, Resolution, Measurement, Mode_String, Range_String, Data_String);
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult);
            return pInvokeResult;
        }
        
        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }
        
        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }
        
        public void SetInt32(niDMMProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetInt32(niDMMProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }
        
        public int GetInt32(niDMMProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public int GetInt32(niDMMProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }
        
        public void SetDouble(niDMMProperties propertyId, string repeatedCapabilityOrChannel, System.Double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetDouble(niDMMProperties propertyId, System.Double val)
        {
            this.SetDouble(propertyId, "", val);
        }
        
        public System.Double GetDouble(niDMMProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }
        
        public System.Double GetDouble(niDMMProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }
        
        public void SetBoolean(niDMMProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }
        
        public void SetBoolean(niDMMProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }
        
        public bool GetBoolean(niDMMProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.UInt16 val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }
        
        public bool GetBoolean(niDMMProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }
        
        public void SetString(niDMMProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }
        
        public void SetString(niDMMProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }
        
        public string GetString(niDMMProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }
        
        public string GetString(niDMMProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }
        
        private class PInvoke
        {
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_init",CallingConvention=CallingConvention.StdCall)]
            public static extern int init (string Resource_Name, System.UInt16 ID__Query, System.UInt16 Reset_Device, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_InitWithOptions",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitWithOptions (string Resource_Name, System.UInt16 ID__Query, System.UInt16 Reset_Device, string Option_String, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_InitExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int InitExtCal (string Resource_Name, string Calibration_Password, out System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureMeasurement",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureMeasurement (System.IntPtr Instrument_Handle, int Measurement_Function, System.Double Range, System.Double Resolution);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureMultiPoint",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureMultiPoint (System.IntPtr Instrument_Handle, int Trigger_Count, int Sample_Count, int Sample_Trigger, System.Double Sample_Interval);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureWaveformAcquisition",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureWaveformAcquisition (System.IntPtr Instrument_Handle, int Measurement_Function, System.Double Range, System.Double Rate, int Waveform_Points);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigurePowerLineFrequency",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigurePowerLineFrequency (System.IntPtr Instrument_Handle, System.Double Power_Line_Frequency);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureAutoZeroMode",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureAutoZeroMode (System.IntPtr Instrument_Handle, int Auto_Zero_Mode);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureADCCalibration",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureADCCalibration (System.IntPtr Instrument_Handle, int ADC__Calibration);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureOffsetCompOhms",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureOffsetCompOhms (System.IntPtr Instrument_Handle, int Offset_Comp_Ohms);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureACBandwidth",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureACBandwidth (System.IntPtr Instrument_Handle, System.Double AC__Minimum_Frequency_Hz, System.Double AC__Maximum_Frequency_Hz);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureFrequencyVoltageRange",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureFrequencyVoltageRange (System.IntPtr Instrument_Handle, System.Double Voltage_Range);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureCurrentSource",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureCurrentSource (System.IntPtr Instrument_Handle, System.Double Current_Source);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureWaveformCoupling",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureWaveformCoupling (System.IntPtr Instrument_Handle, int Waveform_Coupling);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureTrigger",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureTrigger (System.IntPtr Instrument_Handle, int Trigger_Source, System.Double Trigger_Delay);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SendSoftwareTrigger",CallingConvention=CallingConvention.StdCall)]
            public static extern int SendSoftwareTrigger (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureMeasCompleteDest",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureMeasCompleteDest (System.IntPtr Instrument_Handle, int Meas_Complete_Destination);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureTriggerSlope",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureTriggerSlope (System.IntPtr Instrument_Handle, int Trigger_Slope);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureSampleTriggerSlope",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureSampleTriggerSlope (System.IntPtr Instrument_Handle, int Sample_Trigger_Slope);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ConfigureMeasCompleteSlope",CallingConvention=CallingConvention.StdCall)]
            public static extern int ConfigureMeasCompleteSlope (System.IntPtr Instrument_Handle, int Meas_Complete_Slope);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAutoRangeValue",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAutoRangeValue (System.IntPtr Instrument_Handle, out System.Double Actual_Range);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetApertureTimeInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetApertureTimeInfo (System.IntPtr Instrument_Handle, out System.Double Aperture_Time, out int Aperture_Time_Units);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetMeasurementPeriod",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetMeasurementPeriod (System.IntPtr Instrument_Handle, out System.Double Period);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_Read",CallingConvention=CallingConvention.StdCall)]
            public static extern int Read (System.IntPtr Instrument_Handle, int Maximum_Time, out System.Double Reading);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ReadMultiPoint",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadMultiPoint (System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] System.Double[] Reading_Array, out int Actual_Number_Of_Points);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ReadWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadWaveform (System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] System.Double[] Waveform_Array, out int Actual_Number_Of_Points);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_IsOverRange",CallingConvention=CallingConvention.StdCall)]
            public static extern int IsOverRange (System.IntPtr Instrument_Handle, System.Double Measurement_Value, out System.UInt16 Is_Over_Range);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_Initiate",CallingConvention=CallingConvention.StdCall)]
            public static extern int Initiate (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_Fetch",CallingConvention=CallingConvention.StdCall)]
            public static extern int Fetch (System.IntPtr Instrument_Handle, int Maximum_Time, out System.Double Reading);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_FetchMultiPoint",CallingConvention=CallingConvention.StdCall)]
            public static extern int FetchMultiPoint (System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] System.Double[] Reading_Array, out int Actual_Number_Of_Points);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_FetchWaveform",CallingConvention=CallingConvention.StdCall)]
            public static extern int FetchWaveform (System.IntPtr Instrument_Handle, int Maximum_Time, int Array_Size, [In, Out] System.Double[] Waveform_Array, out int Actual_Number_Of_Points);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_Abort",CallingConvention=CallingConvention.StdCall)]
            public static extern int Abort (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ReadStatus",CallingConvention=CallingConvention.StdCall)]
            public static extern int ReadStatus (System.IntPtr Instrument_Handle, out int Acquisition_Backlog, out short Acquisition_Status);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SelfCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int SelfCal (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_CalAdjustGain",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustGain (System.IntPtr Instrument_Handle, int Mode, System.Double Range, System.Double Input_Resistance, System.Double Expected_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_CalAdjustOffset",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustOffset (System.IntPtr Instrument_Handle, int Mode, System.Double Range, System.Double Input_Resistance);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_CalAdjustMisc",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustMisc (System.IntPtr Instrument_Handle, int Type);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_CalAdjustACFilter",CallingConvention=CallingConvention.StdCall)]
            public static extern int CalAdjustACFilter (System.IntPtr Instrument_Handle, int Mode, System.Double Range, System.Double Frequency, System.Double Expected_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_CloseExtCal",CallingConvention=CallingConvention.StdCall)]
            public static extern int CloseExtCal (System.IntPtr Instrument_Handle, int Action);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetCalCount",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalCount (System.IntPtr Instrument_Handle, int Cal_Type, out int Count);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetCalDateAndTime",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalDateAndTime (System.IntPtr Instrument_Handle, int Cal_Type, out int Month, out int Day, out int Year, out int Hour, out int Minute);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetDevTemp",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetDevTemp (System.IntPtr Instrument_Handle, string Options, out System.Double Temperature);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetLastCalTemp",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetLastCalTemp (System.IntPtr Instrument_Handle, int Cal_Type, out System.Double Temperature);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetCalUserDefinedInfoMaxSize",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize (System.IntPtr Instrument_Handle, out int Info_Size);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Info);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetCalUserDefinedInfo",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo (System.IntPtr Instrument_Handle, string Info);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetExtCalRecommendedInterval",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval (System.IntPtr Instrument_Handle, out int Months);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetSelfCalSupported",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetSelfCalSupported (System.IntPtr Instrument_Handle, out System.UInt16 Self_Cal_Supported);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_RestoreLastExtCalConstants",CallingConvention=CallingConvention.StdCall)]
            public static extern int RestoreLastExtCalConstants (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetCalPassword",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetCalPassword (System.IntPtr Instrument_Handle, string Old_Password, string New_Password);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_reset",CallingConvention=CallingConvention.StdCall)]
            public static extern int reset (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ResetWithDefaults",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetWithDefaults (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_self_test",CallingConvention=CallingConvention.StdCall)]
            public static extern int self_test (System.IntPtr Instrument_Handle, out short Self_Test_Result, System.Text.StringBuilder Self___Test_Message);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_revision_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int revision_query (System.IntPtr Instrument_Handle, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_Disable",CallingConvention=CallingConvention.StdCall)]
            public static extern int Disable (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetChannelName",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetChannelName (System.IntPtr Instrument_Handle, int Index, int Buffer_Size, System.Text.StringBuilder Channel_String);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetDigitsofPrecision",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetDigitsofPrecision (System.IntPtr Instrument_Handle, out System.Double Digits);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_error_query",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_query (System.IntPtr Instrument_Handle, out int Error_Code, System.Text.StringBuilder Error_Message);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetNextInterchangeWarning",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ClearInterchangeWarnings",CallingConvention=CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_ResetInterchangeCheck",CallingConvention=CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetNextCoercionRecord",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord (System.IntPtr Instrument_Handle, int Buffer_Size, System.Text.StringBuilder Coercion_Record);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_FormatMeasAbsolute",CallingConvention=CallingConvention.StdCall)]
            public static extern int FormatMeasAbsolute (int Measurement_Function, System.Double Range, System.Double Resolution, System.Double Measurement, System.Text.StringBuilder Mode_String, System.Text.StringBuilder Range_String, System.Text.StringBuilder Data_String);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_close",CallingConvention=CallingConvention.StdCall)]
            public static extern int close (System.IntPtr Instrument_Handle);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_error_message",CallingConvention=CallingConvention.StdCall)]
            public static extern int error_message (System.IntPtr Instrument_Handle, int Error_Code, System.Text.StringBuilder Error_Message_2);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.UInt16 Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out int Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.Double Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Buffer_Size, System.Text.StringBuilder Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetAttributeViBoolean",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.UInt16 Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetAttributeViInt32",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, int Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetAttributeViReal64",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64 (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.Double Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetAttributeViSession",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViSession (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_SetAttributeViString",CallingConvention=CallingConvention.StdCall)]
            public static extern int SetAttributeViString (System.IntPtr Instrument_Handle, string Channel_Name, int Attribute_ID, string Attribute_Value);
            
            [DllImport("niDMM_32.dll",EntryPoint="niDMM_GetError",CallingConvention=CallingConvention.StdCall)]
            public static extern int GetError (System.IntPtr Instrument_Handle, out int Error_Code, int Buffer_Size, System.Text.StringBuilder Description);
            
            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }
            
            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }
    
    public class niDMMConstants
    {
        
        public const int Positive = 0;
        
        public const System.Double _1Milliamp = 0.001;
        
        public const int ExtcalMisccalSection = 5;
        
        public const int AcVolts = 2;
        
        public const int Negative = 1;
        
        public const int None = -1;
        
        public const int DcCurrent = 3;
        
        public const int WaveformCurrent = 1004;
        
        public const int AdcCalibrationOn = 1;
        
        public const int Ttl6 = 117;
        
        public const int Ttl7 = 118;
        
        public const int Ttl4 = 115;
        
        public const int Ttl5 = 116;
        
        public const int AcCurrent = 4;
        
        public const int Ttl3 = 114;
        
        public const int SoftwareTrig = 3;
        
        public const int Ttl1 = 112;
        
        public const int AcVoltsDcCoupled = 1001;
        
        public const int AutoZeroAuto = -1;
        
        public const int Interval = 10;
        
        public const int WaveformCouplingAc = 0;
        
        public const int Ttl2 = 113;
        
        public const int External = 2;
        
        public const int Ttl0 = 111;
        
        public const System.Double GreaterThan10Gigaohm = 10000000000;
        
        public const int OffsetCompOhmsOff = 0;
        
        public const int DcVolts = 1;
        
        public const int AdcCalibrationAuto = -1;
        
        public const int AuxTrig1 = 1001;
        
        public const int _2WireRes = 5;
        
        public const int AutoZeroOff = 0;
        
        public const int _4WireRes = 101;
        
        public const int ExtcalMisccalVref = 0;
        
        public const int AdcCalibrationOff = 0;
        
        public const int AutoZeroOn = 1;
        
        public const int ExtcalMisccalRref = 1;
        
        public const int LbrTrig1 = 1004;
        
        public const int OffsetCompOhmsOn = 1;
        
        public const System.Double _10Microamp = 1E-05;
        
        public const int WaveformCouplingDc = 1;
        
        public const System.Double _50Hertz = 50;
        
        public const int AutoZeroOnce = 2;
        
        public const int Period = 105;
        
        public const int PxiStar = 131;
        
        public const int ExtcalMisccal2wireleakage = 3;
        
        public const System.Double _60Hertz = 60;
        
        public const System.Double ResistanceNa = 0;
        
        public const int ExtcalMisccalZint = 2;
        
        public const int ExtcalActionSave = 1;
        
        public const int ExternalArea = 1;
        
        public const int Immediate = 1;
        
        public const int Diode = 1002;
        
        public const int ExtcalMisccal4wireleakage = 4;
        
        public const int InternalArea = 0;
        
        public const System.Double _10Megaohm = 10000000;
        
        public const int Freq = 104;
        
        public const System.Double _1Microamp = 1E-06;
        
        public const int WaveformVoltage = 1003;
        
        public const int ExtcalActionAbort = 0;
        
        public const System.Double _100Microamp = 0.0001;
        
        public const System.Double _1Megaohm = 1000000;
    }
    
    public enum niDMMProperties
    {
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,
        
        /// <summary>
        /// System.String
        /// </summary>
        DriverSetup = 1050007,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,
        
        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverMajorVersion = 1050503,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverMinorVersion = 1050504,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,
        
        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,
        
        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,
        
        /// <summary>
        /// System.String
        /// </summary>
        IoResourceDescriptor = 1050304,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,
        
        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,
        
        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,
        
        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,
        
        /// <summary>
        /// System.Double
        /// </summary>
        AutoRangeValue = 1250331,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        Function = 1250001,
        
        /// <summary>
        /// System.Double
        /// </summary>
        Range = 1250002,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ResolutionAbsolute = 1250008,
        
        /// <summary>
        /// System.Double
        /// </summary>
        AcMaxFreq = 1250007,
        
        /// <summary>
        /// System.Double
        /// </summary>
        AcMinFreq = 1250006,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        AdcCalibration = 1150022,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        AutoZero = 1250332,
        
        /// <summary>
        /// System.Double
        /// </summary>
        CurrentSource = 1150025,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        DcNoiseRejection = 1150026,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FreqVoltageAutoRangeValue = 1150044,
        
        /// <summary>
        /// System.Double
        /// </summary>
        FreqVoltageRange = 1250101,
        
        /// <summary>
        /// System.Double
        /// </summary>
        InputResistance = 1150029,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OffsetCompOhms = 1150023,
        
        /// <summary>
        /// System.Double
        /// </summary>
        PowerlineFreq = 1250333,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ShuntValue = 1150003,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MeasCompleteDest = 1250305,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        MeasDestSlope = 1150002,
        
        /// <summary>
        /// System.Double
        /// </summary>
        TriggerDelay = 1250005,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSlope = 1250334,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSource = 1250004,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        BufferSize = 1150037,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        Latency = 1150034,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SampleCount = 1250301,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SampleDelayMode = 1150031,
        
        /// <summary>
        /// System.Double
        /// </summary>
        SampleInterval = 1250303,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SampleTrigger = 1250302,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        SampleTriggerSlope = 1150010,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerCount = 1250304,
        
        /// <summary>
        /// System.Double
        /// </summary>
        ApertureTime = 1250321,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        ApertureTimeUnits = 1250322,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        NumberOfAverages = 1150032,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        OperationMode = 1150014,
        
        /// <summary>
        /// System.Double
        /// </summary>
        SettleTime = 1150028,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformCoupling = 1150027,
        
        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformPoints = 1150019,
        
        /// <summary>
        /// System.Double
        /// </summary>
        WaveformRate = 1150018,
    }
}
